----------------------------------------------------------------------------------
-- Company:
-- Engineer:
--
-- Create Date: 11/16/2017 08:12:08 AM
-- Design Name:
-- Module Name: HashNator - Behavioral
-- Project Name:
-- Target Devices:
-- Tool Versions:
-- Description:
--
-- Dependencies:
--
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity HashNator is
    Generic( hashWidth : natural := 14);
    Port ( clk : in STD_LOGIC;
           ce : in STD_LOGIC;
           rst : in STD_LOGIC;
           data : in STD_LOGIC_VECTOR (31 downto 0);
           hash : out STD_LOGIC_VECTOR (hashWidth-1 downto 0));
end HashNator;

architecture Behavioral of HashNator is
COMPONENT HashMultiplier IS
  PORT (
    CLK : IN STD_LOGIC;
    A : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    CE : IN STD_LOGIC;
    P : OUT STD_LOGIC_VECTOR(63 DOWNTO 0);
    SCLR : IN STD_LOGIC
  );
END COMPONENT;

signal P_OUT : STD_LOGIC_VECTOR(63 DOWNTO 0);
begin

mult : HashMultiplier
  PORT MAP (
    CLK => clk,
    A => data,
    CE => ce,
    P => P_OUT,
    SCLR => rst
  );

  hash <= P_OUT(63 DOWNTO 64-hashWidth);
end Behavioral;
